<template>
    <app-layout>
        <template #header>File Manager</template>
        <panel>
            <template #breadcrumbs>
                <inertia-link :href="'/files/' + userId" class="text-blue-500 font-bold" v-if="username && username != $page.user.name">{{username}}'s Files</inertia-link>
                <inertia-link href="/files" class="text-blue-500 font-bold" v-else>My Files</inertia-link>
                <div v-for="(item,i) in breadcrumb" :key="i">
                    <span class="mx-2">/</span>
                    <inertia-link :href="'/files/' + path.split('/').slice(0,i+2).join('/')" class="text-blue-500 font-bold" v-if="i < breadcrumb.length-1">{{item}}</inertia-link>
                    <span v-else>{{item}}</span>
                </div>
            </template>
            <template #header>
                <label class="bg-orange-500 hover:bg-orange-600 rounded py-1 px-2 " @click.stop="">
                    <feather type="upload" class="h-4" /> Upload Replacement
                    <input type="file" class="hidden" @change="beginUpload" accept=".tar,.zip,.bmp,.gif,.jpeg,.png,.svg,.tiff,.ico,.mp4,.webm,.ogv,.html,.pdf" />
                </label>
                <button class="bg-red-500 hover:bg-red-600 rounded py-1 px-2 ml-2" @click.stop="">
                    <feather type="trash-2" class="h-4" />
                    Delete
                </button>
                <label class="bg-green-500 hover:bg-green-600 rounded py-1 px-2 " @click.stop="save" v-if="edited">
                    <feather type="save" class="h-4" /> Save
                </label>
            </template>
            <div class="flex shadow-xl sm:rounded-lg-b content-center items-center w-full bg-gray-200 dark:bg-gray-800" v-show="loading">
                <div class="flex-1 mx-auto text-center text-5xl dark:text-white">
                    Loading File<br><fa-icon icon="spinner" class="animate-spin" />
                </div>
            </div>
            <div v-show="!loading">
                <div v-if="uploadFilename != ''" class="w-full bg-gray-500 mb-3">
                    <div class="h-5 bg-green-600 px-3 text-sm text-white" :style="{'width':uploadProgress+'%'}">
                        Uploading {{ uploadFilename }} ... {{ uploadProgress }}%
                    </div>
                </div>
                <div class="flex justify-center items-center px-4 py-2" v-if="format.startsWith('image/')">
                    <img class="max-w-full" :src="url + '?raw=1'" @load="loading=false" />
                </div>
                <div class="flex justify-center items-center px-4 py-2" v-if="format.startsWith('video/')">
                    <video class="w-full" :src="url + '?raw=1'" controls  @canplay="loading=false" />
                </div>
                <div class="pt-2" v-if="format.startsWith('text')">
                    <monaco-editor class="editor" v-model="content" :language="language" @editorDidMount="loading=false" @change="edited = true" />
                </div>
                <div v-if="format == 'application/pdf'">
                    <embed class="editor" :src="url + '?raw=1'" @load="loading=false" />
                </div>
            </div>
        </panel>
    </app-layout>
</template>

<style>
.editor {
  width: 100%;
  height: 50vh;
  min-height: 500px;
  @apply rounded-b;
}
</style>

<script>
    import dayjs from 'dayjs'
    import MonacoEditor from 'vue-monaco'

    export default {
        components: {
            MonacoEditor,
        },
        props: {
            name: String,
            updated_at: Number,
            format: String,
            size: Number,
            url: String,
            path: String,
            file: {
                type: String,
                default: "No File",
            },
            language: {
                type: String,
                default: "",
            },
        },
        data(){
            const breadcrumb = this.path.split('/');
            breadcrumb.shift();
            return {
                uploadProgress: 0,
                uploadFilename: "",
                modified: dayjs.unix(this.updated_at),
                content: this.file,
                breadcrumb,
                loading: true,
                edited: false,
            }
        },
        methods: {
            beginUpload(evt){
                return; // disable
                const files = evt.target.files;
                for(let i = 0; i < evt.target.files.length; i++){
                    let file = evt.target.files[i];
                    console.log("File",evt.target.files[i]);
                    const data = new FormData();
                    data.append('file',file);
                    this.$inertia.post('/files', data, {
                        //preserveState: true,
                        preserveScroll: true,
                        onStart: () => {
                            this.uploadFilename = file.name;
                        },
                        onProgress: progress => {
                            this.uploadProgress = Math.round((progress.loaded / progress.total) * 100);
                        },
                        onSuccess: page => {
                            this.uploadFilename = '';
                        },
                    });
                }
            },
            save(evt){
                const data = {
                    content: this.content,
                };
                this.$inertia.put('',data,{ // send to same path as current page
                    preserveState: true,
                    preserveScroll: true,
                    onSuccess: page => {
                        this.edited = false;
                    }
                });
            },
        }
    }
</script>